#!/bin/sh

# currently needs a "head" command with the -c option
# look into using dd or something else to replace this POSIXly

state="fb"

clear

answer() {
	if [ "$1" = "correct" ] ; then
		ikna correct
	elif [ "$1" = "incorrect" ] ; then
		ikna incorrect
	fi

	state="fb"
	clear
}

edit_current_card() {
	card="$(ikna status | awk '/^current_card_id / {print $2}')"
	${EDITOR:=vi} "$card"

	state="fb"
	clear
}

delete_current_card() {
	card="$(ikna status | awk '/^current_card_id / {print $2}')"
	ikna delete "$card"

	state="fb"
	clear

	printf "deleted card $card\n"
	printf '\n--------------\n\n'
}

while true; do
	front="$(ikna front)"

	if [ ! "$front" ] ; then
		printf "No more reviews today! :D\n"
		break
	fi

	if [ "$state" = "fb" ] ; then 
		ikna front 
	elif [ "$state" = "ic" ] ; then
		printf '\n\n\n\n\n\n--------------\n'
		printf '(c)orrect (i)ncorrect\n'
		printf '(e)dit (d)elete\n'
		printf '(q)uit\n'
		printf '> '
	fi

	prev_tty="$(stty -g)"
	stty raw -echo ; input="$(head -c 1)" ; stty "$prev_tty"

	if [ "$state" = "fb" ] ; then
		case "$input" in
			'q') printf "\n" ; break ;;
			' ') 
				printf "\n" 
				ikna back 
				state="ic"
				;;
			*) printf "%s is not a valid input\n" "$input" ;;
		esac
	elif [ "$state" = "ic" ] ; then
		case "$input" in
			'q') printf "\n" ; break ;;
			'i') answer "incorrect" ;;
			'c'|' ') answer "correct" ;;
			'e') edit_current_card ;;
			'd') delete_current_card ;;
			*) printf "%s is not a valid input\n" "$input" ;;
		esac
	fi
done
